Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs	(revision 4091)
@@ -41,5 +41,5 @@
   /// in parallel.
   /// </summary>
-  public class HiveEngine : ItemBase, IEngine, IEditable {
+  public class HiveEngine : HeuristicLab.Core.Engine {
     private const int SNAPSHOT_POLLING_INTERVAL_MS = 1000;
     private const int RESULT_POLLING_INTERVAL_MS = 10000;
@@ -60,13 +60,11 @@
     }
 
-    #region IEngine Members
-
-    public IOperatorGraph OperatorGraph {
-      get { return job.Engine.OperatorGraph; }
-    }
-
-    public IScope GlobalScope {
-      get { return job.Engine.GlobalScope; }
-    }
+    //public OperatorGraph OperatorGraph {
+    //  get { return job.Engine.OperatorGraph; }
+    //}
+
+    //public IScope GlobalScope {
+    //  get { return job.Engine.GlobalScope; }
+    //}
 
     public TimeSpan ExecutionTime {
@@ -75,21 +73,25 @@
 
     public ThreadPriority Priority {
-      get { return job.Engine.Priority; }
-      set { job.Engine.Priority = value; }
-    }
-
-    public bool Running {
-      get { return job.Engine.Running; }
-    }
-
-    public bool Canceled {
-      get { return job.Engine.Canceled; }
-    }
-
-    public bool Terminated {
-      get { return job.Engine.Terminated; }
-    }
-
-    public void Execute() {
+      get { return this.Priority; }
+      set { this.Priority = value; }
+    }
+
+    //public bool Running {
+    //  get { return job.Engine.ExecutionState == Core.ExecutionState.Started; }
+    //}
+
+    //public bool Canceled {
+    //  get { return job.Engine.Canceled; }
+    //}
+
+    //public bool Terminated {
+    //  get { return job.Engine.Terminated; }
+    //}
+
+    public ExecutionState ExecutionState {
+      get { return job.Engine.ExecutionState; }
+    }
+
+    protected override void ProcessNextOperation() {
       var jobObj = CreateJobObj();
       IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(HiveServerUrl);
@@ -97,5 +99,5 @@
       List<string> groups = new List<string>();
       if (!String.Empty.Equals(RessourceIds)) {
-        groups.AddRange(RessourceIds.Split(';'));        
+        groups.AddRange(RessourceIds.Split(';'));
       }
 
@@ -110,10 +112,10 @@
           }   
         }
-      } */     
+      } */
 
       int loops = 1;
-      
+
       Int32.TryParse(MultiSubmitCount, out loops);
-      if(loops == 0)
+      if (loops == 0)
         loops = 1;
 
@@ -122,5 +124,5 @@
         jobId = res.Obj.Id;
       }
-      
+
       StartResultPollingThread();
     }
@@ -144,7 +146,8 @@
             // 4. the result that we get from the server is a snapshot and not the final result
             if (abortRequested) return;
-              if (response.Success && response.Obj != null && response.StatusMessage != ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE) {
+            if (response.Success && response.Obj != null && response.StatusMessage != ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE) {
               Logger.Debug("HiveEngine: Results-polling - Got result!");
-              restoredJob = (Job)PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobData);
+              throw new NotImplementedException("TODO[chn]use persistency-3.3");
+              //restoredJob = (Job)PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobData);
               Logger.Debug("HiveEngine: Results-polling - IsSnapshotResult: " + (restoredJob.Progress < 1.0));
             }
@@ -153,7 +156,9 @@
 
         job = restoredJob;
-        ControlManager.Manager.ShowControl(job.Engine.CreateView());
-        OnChanged();
-        OnFinished();
+
+        //ControlManager.Manager.ShowControl(job.Engine.CreateView());
+        //OnChanged();
+
+        //OnFinished();
       });
       Logger.Debug("HiveEngine: Starting results-polling thread");
@@ -161,193 +166,182 @@
     }
 
-    public void RequestSnapshot() {
-      IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(HiveServerUrl);
-      int retryCount = 0;
-      ResponseObject<SerializedJob> response;
-      lock (locker) {
-        Logger.Debug("HiveEngine: Abort - RequestSnapshot");
-        Response snapShotResponse = executionEngineFacade.RequestSnapshot(jobId);
-        if (snapShotResponse.StatusMessage == ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED) {
-          // job is finished already
-          Logger.Debug("HiveEngine: Abort - GetLastResult(false)");
-          response = executionEngineFacade.GetLastSerializedResult(jobId, false, false);
-          Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
-        } else {
-          // server sent snapshot request to client
-          // poll until snapshot is ready
-          do {
-            Thread.Sleep(SNAPSHOT_POLLING_INTERVAL_MS);
-            Logger.Debug("HiveEngine: Abort - GetLastResult(true)");
-            response = executionEngineFacade.GetLastSerializedResult(jobId, false, true);
-            Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
-            retryCount++;
-            // loop while
-            // 1. problem with communication with server
-            // 2. job result not yet ready
-          } while (
-            (retryCount < MAX_SNAPSHOT_RETRIES) && (
-            !response.Success ||
-            response.StatusMessage == ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE)
-            );
-        }
-      }
-      SerializedJob jobResult = response.Obj;
-      if (jobResult != null) {
-        Logger.Debug("HiveEngine: Results-polling - Got result!");
-        job = (Job)PersistenceManager.RestoreFromGZip(jobResult.SerializedJobData);
-        ControlManager.Manager.ShowControl(job.Engine.CreateView());
-      }
-      //HiveLogger.Debug("HiveEngine: Results-polling - Exception!");
-      //Exception ex = new Exception(response.Obj.Exception.Message);
-      //ThreadPool.QueueUserWorkItem(delegate(object state) { OnExceptionOccurred(ex); });
-    }
-
-    public void ExecuteStep() {
-      throw new NotSupportedException();
-    }
-
-    public void ExecuteSteps(int steps) {
-      throw new NotSupportedException();
-    }
-
-    public void Abort() {
-      abortRequested = true;
-      // RequestSnapshot();
-      IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(HiveServerUrl);
-      executionEngineFacade.AbortJob(jobId);
-      OnChanged();
-      OnFinished();
-    }
-
-    public void Reset() {
-      abortRequested = false;
-      job.Engine.Reset();
-      jobId = Guid.NewGuid();
-      OnInitialized();
-    }
-
     private HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob CreateJobObj() {
       HeuristicLab.Hive.Contracts.BusinessObjects.JobDto jobObj =
         new HeuristicLab.Hive.Contracts.BusinessObjects.JobDto();
 
-      MemoryStream memStream = new MemoryStream();
-      GZipStream stream = new GZipStream(memStream, CompressionMode.Compress, true);
-      XmlDocument document = PersistenceManager.CreateXmlDocument();
-      Dictionary<Guid, IStorable> dictionary = new Dictionary<Guid, IStorable>();
-      XmlNode rootNode = document.CreateElement("Root");
-      document.AppendChild(rootNode);
-      rootNode.AppendChild(PersistenceManager.Persist(job, document, dictionary));
-      document.Save(stream);
-      stream.Close();
-
-      HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob executableJobObj =
-        new HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob();
-      executableJobObj.JobInfo = jobObj;
-      executableJobObj.SerializedJobData = memStream.ToArray();
-
-      List<IPluginDescription> plugins = new List<IPluginDescription>();
-
-      foreach (IStorable storeable in dictionary.Values) {
-        IPluginDescription pluginInfo = ApplicationManager.Manager.GetDeclaringPlugin(storeable.GetType());
-        if (!plugins.Contains(pluginInfo)) {
-          plugins.Add(pluginInfo);
-          foreach (var dependency in pluginInfo.Dependencies) {
-            if (!plugins.Contains(dependency)) plugins.Add(dependency);
-          }
-        }
-      }
-
-      List<HivePluginInfoDto> pluginsNeeded =
-        new List<HivePluginInfoDto>();
-      foreach (IPluginDescription uniquePlugin in plugins) {
-        HivePluginInfoDto pluginInfo =
-          new HivePluginInfoDto();
-        pluginInfo.Name = uniquePlugin.Name;
-        pluginInfo.Version = uniquePlugin.Version;
-        pluginInfo.BuildDate = uniquePlugin.BuildDate;
-        pluginsNeeded.Add(pluginInfo);
-      }
-
-      jobObj.CoresNeeded = 1;
-      jobObj.PluginsNeeded = pluginsNeeded;
-      jobObj.State = HeuristicLab.Hive.Contracts.BusinessObjects.State.offline;
-      return executableJobObj;
-    }
-
-    public event EventHandler Initialized;
-    /// <summary>
-    /// Fires a new <c>Initialized</c> event.
-    /// </summary>
-    protected virtual void OnInitialized() {
-      if (Initialized != null)
-        Initialized(this, new EventArgs());
-    }
-
-    public event EventHandler<EventArgs<IOperation>> OperationExecuted;
-    /// <summary>
-    /// Fires a new <c>OperationExecuted</c> event.
-    /// </summary>
-    /// <param name="operation">The operation that has been executed.</param>
-    protected virtual void OnOperationExecuted(IOperation operation) {
-      if (OperationExecuted != null)
-        OperationExecuted(this, new EventArgs<IOperation>(operation));
-    }
-
-    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
-    /// <summary>
-    /// Aborts the execution and fires a new <c>ExceptionOccurred</c> event.
-    /// </summary>
-    /// <param name="exception">The exception that was thrown.</param>
-    protected virtual void OnExceptionOccurred(Exception exception) {
-      Abort();
-      if (ExceptionOccurred != null)
-        ExceptionOccurred(this, new EventArgs<Exception>(exception));
-    }
-
-    public event EventHandler ExecutionTimeChanged;
-    /// <summary>
-    /// Fires a new <c>ExecutionTimeChanged</c> event.
-    /// </summary>
-    protected virtual void OnExecutionTimeChanged() {
-      if (ExecutionTimeChanged != null)
-        ExecutionTimeChanged(this, new EventArgs());
-    }
-
-    public event EventHandler Finished;
-    /// <summary>
-    /// Fires a new <c>Finished</c> event.
-    /// </summary>
-    protected virtual void OnFinished() {
-      if (Finished != null)
-        Finished(this, new EventArgs());
-    }
-
-    #endregion
-
-    public override IView CreateView() {
-      return new HiveEngineEditor(this);
-    }
-
-    #region IEditable Members
-
-    public IEditor CreateEditor() {
-      return new HiveEngineEditor(this);
-    }
-    #endregion
-
-    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      XmlAttribute attr = document.CreateAttribute("HiveServerUrl");
-      attr.Value = HiveServerUrl;
-      node.Attributes.Append(attr);
-      node.AppendChild(PersistenceManager.Persist("Job", job, document, persistedObjects));
-      return node;
-    }
-
-    public override void Populate(System.Xml.XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-      HiveServerUrl = node.Attributes["HiveServerUrl"].Value;
-      job = (Job)PersistenceManager.Restore(node.SelectSingleNode("Job"), restoredObjects);
-    }
+
+      throw new NotImplementedException("TODO[chn]use persistency-3.3");
+
+      //MemoryStream memStream = new MemoryStream();
+      //GZipStream stream = new GZipStream(memStream, CompressionMode.Compress, true);
+      //XmlDocument document = PersistenceManager.CreateXmlDocument();
+      //Dictionary<Guid, IStorable> dictionary = new Dictionary<Guid, IStorable>();
+      //XmlNode rootNode = document.CreateElement("Root");
+      //document.AppendChild(rootNode);
+      //rootNode.AppendChild(PersistenceManager.Persist(job, document, dictionary));
+      //document.Save(stream);
+      //stream.Close();
+
+      //HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob executableJobObj =
+      //  new HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob();
+      //executableJobObj.JobInfo = jobObj;
+      //executableJobObj.SerializedJobData = memStream.ToArray();
+
+      //List<IPluginDescription> plugins = new List<IPluginDescription>();
+
+      //foreach (IStorable storeable in dictionary.Values) {
+      //  IPluginDescription pluginInfo = ApplicationManager.Manager.GetDeclaringPlugin(storeable.GetType());
+      //  if (!plugins.Contains(pluginInfo)) {
+      //    plugins.Add(pluginInfo);
+      //    foreach (var dependency in pluginInfo.Dependencies) {
+      //      if (!plugins.Contains(dependency)) plugins.Add(dependency);
+      //    }
+      //  }
+      //}
+
+      //List<HivePluginInfoDto> pluginsNeeded =
+      //  new List<HivePluginInfoDto>();
+      //foreach (IPluginDescription uniquePlugin in plugins) {
+      //  HivePluginInfoDto pluginInfo =
+      //    new HivePluginInfoDto();
+      //  pluginInfo.Name = uniquePlugin.Name;
+      //  pluginInfo.Version = uniquePlugin.Version;
+      //  pluginInfo.BuildDate = uniquePlugin.BuildDate;
+      //  pluginsNeeded.Add(pluginInfo);
+      //}
+
+      //jobObj.CoresNeeded = 1;
+      //jobObj.PluginsNeeded = pluginsNeeded;
+      //jobObj.State = HeuristicLab.Hive.Contracts.BusinessObjects.State.offline;
+      //return executableJobObj;
+    }
+
+    //public event EventHandler Initialized;
+    ///// <summary>
+    ///// Fires a new <c>Initialized</c> event.
+    ///// </summary>
+    //protected virtual void OnInitialized() {
+    //  if (Initialized != null)
+    //    Initialized(this, new EventArgs());
+    //}
+
+    //public event EventHandler<EventArgs<IOperation>> OperationExecuted;
+    ///// <summary>
+    ///// Fires a new <c>OperationExecuted</c> event.
+    ///// </summary>
+    ///// <param name="operation">The operation that has been executed.</param>
+    //protected virtual void OnOperationExecuted(IOperation operation) {
+    //  if (OperationExecuted != null)
+    //    OperationExecuted(this, new EventArgs<IOperation>(operation));
+    //}
+
+    //public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
+    ///// <summary>
+    ///// Aborts the execution and fires a new <c>ExceptionOccurred</c> event.
+    ///// </summary>
+    ///// <param name="exception">The exception that was thrown.</param>
+    //protected virtual void OnExceptionOccurred(Exception exception) {
+    //  Abort();
+    //  if (ExceptionOccurred != null)
+    //    ExceptionOccurred(this, new EventArgs<Exception>(exception));
+    //}
+
+    //public event EventHandler ExecutionTimeChanged;
+    ///// <summary>
+    ///// Fires a new <c>ExecutionTimeChanged</c> event.
+    ///// </summary>
+    //protected virtual void OnExecutionTimeChanged() {
+    //  if (ExecutionTimeChanged != null)
+    //    ExecutionTimeChanged(this, new EventArgs());
+    //}
+
+    //public event EventHandler Finished;
+    ///// <summary>
+    ///// Fires a new <c>Finished</c> event.
+    ///// </summary>
+    //protected virtual void OnFinished() {
+    //  if (Finished != null)
+    //    Finished(this, new EventArgs());
+    //}
+
+    //public void Abort() {
+    //  abortRequested = true;
+    //  // RequestSnapshot();
+    //  IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(HiveServerUrl);
+    //  executionEngineFacade.AbortJob(jobId);
+    //  //OnChanged();
+    //  OnFinished();
+    //}
+
+    //public void Reset() {
+    //  abortRequested = false;
+
+    //  throw new NotImplementedException("[chn] how to reset Engine?");
+    //  //job.Engine.Reset();
+
+    //  jobId = Guid.NewGuid();
+    //  OnInitialized();
+    //}
+
+    //public void RequestSnapshot() {
+    //  IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(HiveServerUrl);
+    //  int retryCount = 0;
+    //  ResponseObject<SerializedJob> response;
+    //  lock (locker) {
+    //    Logger.Debug("HiveEngine: Abort - RequestSnapshot");
+    //    Response snapShotResponse = executionEngineFacade.RequestSnapshot(jobId);
+    //    if (snapShotResponse.StatusMessage == ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED) {
+    //      // job is finished already
+    //      Logger.Debug("HiveEngine: Abort - GetLastResult(false)");
+    //      response = executionEngineFacade.GetLastSerializedResult(jobId, false, false);
+    //      Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
+    //    } else {
+    //      // server sent snapshot request to client
+    //      // poll until snapshot is ready
+    //      do {
+    //        Thread.Sleep(SNAPSHOT_POLLING_INTERVAL_MS);
+    //        Logger.Debug("HiveEngine: Abort - GetLastResult(true)");
+    //        response = executionEngineFacade.GetLastSerializedResult(jobId, false, true);
+    //        Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
+    //        retryCount++;
+    //        // loop while
+    //        // 1. problem with communication with server
+    //        // 2. job result not yet ready
+    //      } while (
+    //        (retryCount < MAX_SNAPSHOT_RETRIES) && (
+    //        !response.Success ||
+    //        response.StatusMessage == ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE)
+    //        );
+    //    }
+    //  }
+    //  SerializedJob jobResult = response.Obj;
+    //  if (jobResult != null) {
+    //    Logger.Debug("HiveEngine: Results-polling - Got result!");
+
+    //    //job = (Job)PersistenceManager.RestoreFromGZip(jobResult.SerializedJobData);
+    //    //ControlManager.Manager.ShowControl(job.Engine.CreateView());
+    //    throw new NotImplementedException("TODO[chn]use persistency-3.3");
+    //  }
+    //  //HiveLogger.Debug("HiveEngine: Results-polling - Exception!");
+    //  //Exception ex = new Exception(response.Obj.Exception.Message);
+    //  //ThreadPool.QueueUserWorkItem(delegate(object state) { OnExceptionOccurred(ex); });
+    //}
+
+    //public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    //  XmlAttribute attr = document.CreateAttribute("HiveServerUrl");
+    //  attr.Value = HiveServerUrl;
+    //  node.Attributes.Append(attr);
+    //  node.AppendChild(PersistenceManager.Persist("Job", job, document, persistedObjects));
+    //  return node;
+    //}
+
+    //public override void Populate(System.Xml.XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
+    //  HiveServerUrl = node.Attributes["HiveServerUrl"].Value;
+    //  job = (Job)PersistenceManager.Restore(node.SelectSingleNode("Job"), restoredObjects);
+    //}
+
+
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs	(revision 4091)
@@ -32,7 +32,7 @@
 namespace HeuristicLab.Hive.Engine {
   /// <summary>
-  /// Represents an job that wraps an engine that should be executed in the hive.
+  /// Represents a job that wraps an engine that should be executed in the hive.
   /// </summary>
-  public class Job : StorableBase, IJob {
+  public class Job : IJob {
     private IEngine engine;
     public IEngine Engine {
@@ -42,21 +42,22 @@
     public Job()
       : base() {
+      
       engine = new SequentialEngine.SequentialEngine();
-      engine.Priority = ThreadPriority.Lowest;
+      //engine.Priority = ThreadPriority.Lowest;
       RegisterEvents();
     }
 
     private void RegisterEvents() {
-      engine.Finished += new EventHandler(engine_Finished);
+      engine.Stopped += new EventHandler(engine_Stopped);
       engine.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(engine_ExceptionOccurred);
     }
 
     private void DeregisterEvents() {
-      engine.Finished -= new EventHandler(engine_Finished);
+      engine.Stopped -= new EventHandler(engine_Stopped);
       engine.ExceptionOccurred -= new EventHandler<EventArgs<Exception>>(engine_ExceptionOccurred);
     }
 
-    void engine_Finished(object sender, EventArgs e) {
-      if (Engine.Canceled) this.progress = 0.0;
+    void engine_Stopped(object sender, EventArgs e) {
+      if (Engine.ExecutionState != ExecutionState.Stopped) this.progress = 0.0;
       else this.progress = 1.0;
       var listeners = JobStopped;
@@ -86,7 +87,7 @@
     public double Progress {
       get {
-        DoubleData progress = Engine.GlobalScope.GetVariableValue<DoubleData>("Progress", false,
-          false);
-        return progress == null ? this.progress : progress.Data;
+        //DoubleValue progress = Engine.GlobalScope.GetVariableValue<DoubleData>("Progress", false, false); [chn] not possible in 3.3?
+
+        return engine.ExecutionState == ExecutionState.Stopped ? 1.0 : 0.0;
       }
       set { throw new NotSupportedException(); }
@@ -95,5 +96,5 @@
     public bool Running {
       get {
-        return Engine.Running;
+        return Engine.ExecutionState == ExecutionState.Started;
       }
       set {
@@ -107,32 +108,32 @@
 
     public void Start() {
-      Engine.Execute();
+      Engine.Start();
     }
 
     public void Stop() {
-      Engine.Abort();
+      Engine.Stop();
     }
 
     #endregion
 
-    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      XmlAttribute idAttr = document.CreateAttribute("JobId");
-      idAttr.Value = XmlConvert.ToString(JobId);
-      XmlAttribute progressAttr = document.CreateAttribute("Progress");
-      progressAttr.Value = XmlConvert.ToString(progress);
-      node.Attributes.Append(idAttr);
-      node.Attributes.Append(progressAttr);
-      node.AppendChild(PersistenceManager.Persist("Engine", Engine, document, persistedObjects));
-      return node;
-    }
-    public override void Populate(System.Xml.XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-      JobId = XmlConvert.ToInt64(node.Attributes["JobId"].Value);
-      progress = XmlConvert.ToDouble(node.Attributes["Progress"].Value);
-      DeregisterEvents();
-      engine = (SequentialEngine.SequentialEngine)PersistenceManager.Restore(node.SelectSingleNode("Engine"), restoredObjects);
-      RegisterEvents();
-    }
+    //public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    //  XmlAttribute idAttr = document.CreateAttribute("JobId");
+    //  idAttr.Value = XmlConvert.ToString(JobId);
+    //  XmlAttribute progressAttr = document.CreateAttribute("Progress");
+    //  progressAttr.Value = XmlConvert.ToString(progress);
+    //  node.Attributes.Append(idAttr);
+    //  node.Attributes.Append(progressAttr);
+    //  node.AppendChild(PersistenceManager.Persist("Engine", Engine, document, persistedObjects));
+    //  return node;
+    //}
+    //public override void Populate(System.Xml.XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
+    //  JobId = XmlConvert.ToInt64(node.Attributes["JobId"].Value);
+    //  progress = XmlConvert.ToDouble(node.Attributes["Progress"].Value);
+    //  DeregisterEvents();
+    //  engine = (SequentialEngine.SequentialEngine)PersistenceManager.Restore(node.SelectSingleNode("Engine"), restoredObjects);
+    //  RegisterEvents();
+    //}
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/HeuristicLab.Hive.JobBase-3.3.csproj	(revision 4091)
@@ -94,4 +94,7 @@
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4091)
@@ -1,14 +1,17 @@
 ﻿using System;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
 namespace HeuristicLab.Hive.JobBase {
-  public interface IJob: IStorable {
+  public interface IJob {
+    long JobId { get; set; }
+    bool Running { get; set; }
+    double Progress { get; }
+    void Run();
+    void Start();
+    void Stop();
+
     event EventHandler JobStopped;
     event EventHandler JobFailed;
-    long JobId { get; set; }
-    double Progress { get; }
-    void Run();
-    bool Running { get; set; }
-    void Start();
-    void Stop();
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobBase.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobBase.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobBase.cs	(revision 4091)
@@ -27,8 +27,10 @@
 using System.Xml;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Hive.JobBase {
   [Serializable]
-  abstract public class JobBase : StorableBase, IJob {
+  [StorableClass]
+  abstract public class JobBase : IJob {
 
     private Thread thread = null;
@@ -36,8 +38,14 @@
     public event EventHandler JobFailed;
     
-    public long JobId { get; set; }    
-    public double Progress { get; set; }        
+    [Storable]
+    public long JobId { get; set; }
+
+    [Storable]
+    public double Progress { get; set; }
+
+    [Storable]
     public bool Running { get; set; }
-    
+
+    [Storable]
     protected bool abort = false;    
 
@@ -70,19 +78,19 @@
     }
 
-    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    //public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
 
-      XmlNode progr = document.CreateNode(XmlNodeType.Element, "Progress", null);
-      progr.InnerText = Convert.ToString(Progress);
+    //  XmlNode progr = document.CreateNode(XmlNodeType.Element, "Progress", null);
+    //  progr.InnerText = Convert.ToString(Progress);
 
-      node.AppendChild(progr);
-      return node;
-    }
-    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
+    //  node.AppendChild(progr);
+    //  return node;
+    //}
+    //public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
 
-      XmlNode progr = node.SelectSingleNode("Progress");
-      Progress = Convert.ToDouble(progr.InnerText);
-    }
+    //  XmlNode progr = node.SelectSingleNode("Progress");
+    //  Progress = Convert.ToDouble(progr.InnerText);
+    //}
 
     public JobBase() {    
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobPlugin.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobPlugin.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/JobPlugin.cs	(revision 4091)
@@ -6,7 +6,8 @@
 
 namespace HeuristicLab.Hive.JobBase {
-  [Plugin("HeuristicLab.Hive.JobBase-3.3")]
+  [Plugin("HeuristicLab.Hive.JobBase", "3.3")]
   [PluginFile("HeuristicLab.Hive.JobBase-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Core-3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class JobBasePlugin: PluginBase {
   }
